package nl.bos.soapHelloWorld.ws.endpoint;

import nl.bos.types.helloworld.Message;
import nl.bos.types.helloworld.ObjectFactory;
import nl.bos.types.helloworld.User;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.ws.server.endpoint.annotation.Endpoint;
import org.springframework.ws.server.endpoint.annotation.PayloadRoot;
import org.springframework.ws.server.endpoint.annotation.RequestPayload;
import org.springframework.ws.server.endpoint.annotation.ResponsePayload;

@Endpoint
public class HelloWorldEndpoint {
    private static final Logger LOGGER = LoggerFactory.getLogger(HelloWorldEndpoint.class);

    @PayloadRoot(
            namespace = "http://bos.nl/types/helloworld",
            localPart = "user")
    @ResponsePayload
    public Message sayHello(@RequestPayload User request) {
        LOGGER.info("Endpoint received user[firstName={},lastName={}]", request.getFirstName(), request.getLastName());

        String message = "Hello " + request.getFirstName() + " " + request.getLastName() + "!";

        ObjectFactory factory = new ObjectFactory();
        Message response = factory.createMessage();
        response.setMessage(message);

        LOGGER.info("Endpoint sending message='{}'", response.getMessage());
        return response;
    }
}
